AnimalDistributionEvent = {}

local AnimalDistributionEvent_mt = Class(AnimalDistributionEvent, Event)
InitEventClass(AnimalDistributionEvent, "AnimalDistributionEvent")

function AnimalDistributionEvent.emptyNew()
    return Event.new(AnimalDistributionEvent_mt)
end

function AnimalDistributionEvent.new(Husbandry, FeedFromChain, FeedToChain)
    local self = AnimalDistributionEvent.emptyNew()

    self.Husbandry = Husbandry
    self.FeedFromChain = FeedFromChain
    self.FeedToChain = FeedToChain

    return self
end

function AnimalDistributionEvent:readStream(streamId, connection)
    self.Husbandry = NetworkUtil.readNodeObject(streamId)
    self.FeedFromChain = streamReadBool(streamId)
    self.FeedToChain = streamReadBool(streamId)

    self:run(connection)
end

function AnimalDistributionEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.Husbandry)
    streamWriteBool(streamId, self.FeedFromChain)
    streamWriteBool(streamId, self.FeedToChain)
end

function AnimalDistributionEvent:run(connection)
    self.Husbandry.spec_husbandryAnimals.FeedFromChain = self.FeedFromChain
    self.Husbandry.spec_husbandryAnimals.FeedToChain = self.FeedToChain

    if not connection:getIsServer() then
        g_server:broadcastEvent(AnimalDistributionEvent.new(self.Husbandry, self.FeedFromChain, self.FeedToChain), false)
    end
end
