AnimalDistributionGui = {};

function AnimalDistributionGui:updateMenuButtons(Instance)

    if Instance ~= nil then self = Instance end;

    for i = #self.menuButtonInfo, 1, -1 do
        local buttonInfo = self.menuButtonInfo[i]
        if buttonInfo == AnimalDistributionGui.FeedFromChainButton or buttonInfo == AnimalDistributionGui.FeedToChainButton then
            table.remove(self.menuButtonInfo, i)
        end
    end
    
    local textKey = self.selectedHusbandry.spec_husbandryAnimals.FeedFromChain and "text_StopFromChain" or "text_FeedFromChain"
    AnimalDistributionGui.FeedFromChainButton = {
        profile = "buttonOk",
        inputAction = InputAction.MENU_EXTRA_1,
        text = g_i18n:getText(textKey),
        callback = function() 
            AnimalDistributionGui:FeedFromChainButtonClicked(self.selectedHusbandry)
            AnimalDistributionGui:updateMenuButtons(self)
        end
    }

    local textKey = self.selectedHusbandry.spec_husbandryAnimals.FeedToChain and "text_StopToChain" or "text_FeedToChain"
    AnimalDistributionGui.FeedToChainButton = {
        profile = "buttonOk",
        inputAction = InputAction.MENU_EXTRA_2,
        text = g_i18n:getText(textKey),
        callback = function() 
            AnimalDistributionGui:FeedToChainButtonClicked(self.selectedHusbandry)
            AnimalDistributionGui:updateMenuButtons(self)
        end
    }

     table.insert(self.menuButtonInfo, AnimalDistributionGui.FeedFromChainButton)
     table.insert(self.menuButtonInfo, AnimalDistributionGui.FeedToChainButton)

     self:setMenuButtonInfoDirty()
end

function AnimalDistributionGui:FeedFromChainButtonClicked(Husbandry)
    if Husbandry == nil then return; end

    Husbandry.spec_husbandryAnimals.FeedFromChain = not Husbandry.spec_husbandryAnimals.FeedFromChain
    g_client:getServerConnection():sendEvent(AnimalDistributionEvent.new(Husbandry, Husbandry.spec_husbandryAnimals.FeedFromChain, Husbandry.spec_husbandryAnimals.FeedToChain))
end

function AnimalDistributionGui:FeedToChainButtonClicked(Husbandry)
    if Husbandry == nil then return; end
    
    Husbandry.spec_husbandryAnimals.FeedToChain = not Husbandry.spec_husbandryAnimals.FeedToChain
    g_client:getServerConnection():sendEvent(AnimalDistributionEvent.new(Husbandry, Husbandry.spec_husbandryAnimals.FeedFromChain, Husbandry.spec_husbandryAnimals.FeedToChain))
end

InGameMenuAnimalsFrame.updateMenuButtons = Utils.appendedFunction(InGameMenuAnimalsFrame.updateMenuButtons, AnimalDistributionGui.updateMenuButtons)