AnimalDistributionSpecialization = {}

function AnimalDistributionSpecialization.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(PlaceableHusbandryAnimals, specializations)
end

function AnimalDistributionSpecialization.registerEventListeners(placeableType)
	SpecializationUtil.registerEventListener(placeableType, "onLoad", AnimalDistributionSpecialization)
    SpecializationUtil.registerEventListener(placeableType, "onReadStream", AnimalDistributionSpecialization)
    SpecializationUtil.registerEventListener(placeableType, "onWriteStream", AnimalDistributionSpecialization)
	SpecializationUtil.registerEventListener(placeableType, "onReadUpdateStream", AnimalDistributionSpecialization)
	SpecializationUtil.registerEventListener(placeableType, "onWriteUpdateStream", AnimalDistributionSpecialization)
end

function AnimalDistributionSpecialization:onLoad(savegame)
    self.spec_husbandryAnimals.FeedFromChain = false;
    self.spec_husbandryAnimals.FeedToChain = false;
end

function AnimalDistributionSpecialization.registerSavegameXMLPaths(schema, basePath)
    schema:register(XMLValueType.BOOL, basePath.."#FeedFromChain", "FeedFromChain", false)
    schema:register(XMLValueType.BOOL, basePath.."#FeedToChain", "FeedToChain", false)
end

function AnimalDistributionSpecialization:saveToXMLFile(xmlFile, key, usedModNames)
    xmlFile:setBool(key.."#FeedFromChain", self.spec_husbandryAnimals.FeedFromChain)
    xmlFile:setBool(key.."#FeedToChain", self.spec_husbandryAnimals.FeedToChain)
end

function AnimalDistributionSpecialization:loadFromXMLFile(xmlFile, key)
    self.spec_husbandryAnimals.FeedFromChain = xmlFile:getBool(key.."#FeedFromChain") or false
    self.spec_husbandryAnimals.FeedToChain = xmlFile:getBool(key.."#FeedToChain") or false
end

function AnimalDistributionSpecialization:onReadStream(streamId, connection)
    self.spec_husbandryAnimals.FeedFromChain = streamReadBool(streamId)
    self.spec_husbandryAnimals.FeedToChain = streamReadBool(streamId)
end

function AnimalDistributionSpecialization:onWriteStream(streamId, connection)
    streamWriteBool(streamId, self.spec_husbandryAnimals.FeedFromChain)
    streamWriteBool(streamId, self.spec_husbandryAnimals.FeedToChain)
end

function AnimalDistributionSpecialization:onReadUpdateStream(streamId, connection)
    self.spec_husbandryAnimals.FeedFromChain = streamReadBool(streamId)
    self.spec_husbandryAnimals.FeedToChain = streamReadBool(streamId)
end

function AnimalDistributionSpecialization:onWriteUpdateStream(streamId, connection)
    streamWriteBool(streamId, self.spec_husbandryAnimals.FeedFromChain)
    streamWriteBool(streamId, self.spec_husbandryAnimals.FeedToChain)
end